.386
.model flat, stdcall
option casemap:none
option readonly

include windows.inc
include kernel32.inc
include user32.inc

include asm_memory.inc
include asm_wnd.inc

include TestZipLib.inc


.const
align 4
MainDlgProcMsgMap dd WM_INITDIALOG, OnMainInitDialog
    dd WM_COMMAND, OnMainDlgCommandMsg
    dd WM_CLOSE, OnClose
    dd WM_NCDESTROY, OnNcDestroy
    dd WM_NULL, NULL


.code

align 4
start:
    invoke GetModuleHandle, NULL
    mov ebx, eax

    ; load our application icon
    invoke LoadImage, ebx, IDI_MAIN_ICON, IMAGE_ICON, SM_CXICON, SM_CYICON, (LR_DEFAULTCOLOR or LR_SHARED)
    mov esi, eax 

    ; register our dialog class
    invoke RegDlgClass, ebx, eax, 0  ; using a message map type of window procedure

    ; set up our message map data -- a list of functions that will be called
    push offset MainDlgProcMsgMap
    call setHookData
    
    ; create our dialog
    mov eax, offset DefaultDlgProc
    invoke CreateDialogParam, ebx, IDD_MAIN_DIALOG, NULL, eax, 0

    ; process message until a WM_QUIT is received
    push eax
    invoke ShowWindow, eax, SW_SHOWNORMAL
    call UpdateWindow
    invoke MsgLoop, NULL

    invoke DestroyIcon, esi
    invoke ExitProcess, eax
end start
